References: bsc#954872

---
 tools/libxl/libxl.c         |    4 ++++
 tools/libxl/libxl_device.c  |    3 ++-
 tools/libxl/libxl_dm.c      |   33 ++++++++++++++++++++++++++++++---
 tools/libxl/libxlu_disk_l.l |    2 ++
 4 files changed, 38 insertions(+), 4 deletions(-)
Index: xen-4.4.4-testing/tools/libxl/libxl.c
===================================================================
--- xen-4.4.4-testing.orig/tools/libxl/libxl.c
+++ xen-4.4.4-testing/tools/libxl/libxl.c
@@ -2555,6 +2555,10 @@ static void device_disk_add(libxl__egc *
                 /* now create a phy device to export the device to the guest */
                 goto do_backend_phy;
             case LIBXL_DISK_BACKEND_QDISK:
+		if (disk->script) {
+                    script = libxl__abs_path(gc, disk->script, libxl__xen_script_dir_path());
+		    flexarray_append_pair(back, "script", script);
+		}
                 flexarray_append(back, "params");
                 flexarray_append(back, libxl__sprintf(gc, "%s:%s",
                               libxl__device_disk_string_of_format(disk->format), disk->pdev_path));
Index: xen-4.4.4-testing/tools/libxl/libxl_device.c
===================================================================
--- xen-4.4.4-testing.orig/tools/libxl/libxl_device.c
+++ xen-4.4.4-testing/tools/libxl/libxl_device.c
@@ -270,7 +270,8 @@ static int disk_try_backend(disk_try_bac
         return backend;
 
     case LIBXL_DISK_BACKEND_QDISK:
-        if (a->disk->script) goto bad_script;
+        LOG(DEBUG, "Disk vdev=%s, uses script=%s on %s backend",
+           a->disk->vdev, a->disk->script, libxl_disk_backend_to_string(backend));
         return backend;
 
     default:
Index: xen-4.4.4-testing/tools/libxl/libxl_dm.c
===================================================================
--- xen-4.4.4-testing.orig/tools/libxl/libxl_dm.c
+++ xen-4.4.4-testing/tools/libxl/libxl_dm.c
@@ -389,6 +389,30 @@ static char *dm_spice_options(libxl__gc
     return opt;
 }
 
+static void libxl__suse_node_to_path(libxl__gc *gc, int domid, const libxl_device_disk *dp, const char **pdev_path)
+{
+    libxl_ctx *ctx = libxl__gc_owner(gc);
+    char *be_path, *node;
+    libxl__device device;
+    libxl_device_disk disk;
+    int rc;
+
+    disk = *dp;
+    rc = libxl__device_from_disk(gc, domid, &disk, &device);
+    if (rc) {
+        LIBXL__LOG(ctx, LIBXL__LOG_WARNING, "libxl__device_from_disk failed %d", rc);
+        return;
+    }
+    be_path = libxl__device_backend_path(gc, &device);
+
+    node = libxl__xs_read(gc, XBT_NULL, libxl__sprintf(gc, "%s/node", be_path));
+    if (!node)
+        return;
+
+    LIBXL__LOG(ctx, LIBXL__LOG_WARNING, "replacing '%s' with '%s' from %s/node, just for qemu-xen", *pdev_path, node, be_path);
+    *pdev_path = node;
+}
+
 static char ** libxl__build_device_model_args_new(libxl__gc *gc,
                                         const char *dm, int guest_domid,
                                         const libxl_domain_config *guest_config,
@@ -735,6 +759,9 @@ static char ** libxl__build_device_model
                 libxl__device_disk_dev_number(disks[i].vdev, &disk, &part);
             const char *format;
             char *drive;
+            const char *pdev_path = disks[i].pdev_path;
+
+            libxl__suse_node_to_path(gc, guest_domid, disks + i, &pdev_path);
 
             if (dev_number == -1) {
                 LIBXL__LOG(ctx, LIBXL__LOG_WARNING, "unable to determine"
@@ -755,7 +782,7 @@ static char ** libxl__build_device_model
                 else
                     drive = libxl__sprintf
                         (gc, "file=%s,if=ide,index=%d,readonly=%s,media=cdrom,format=%s,cache=writeback,id=ide-%i",
-                         disks[i].pdev_path, disk, disks[i].readwrite ? "off" : "on", format, dev_number);
+                         pdev_path, disk, disks[i].readwrite ? "off" : "on", format, dev_number);
             } else {
                 if (disks[i].format == LIBXL_DISK_FORMAT_EMPTY) {
                     LIBXL__LOG(ctx, LIBXL__LOG_WARNING, "cannot support"
@@ -778,7 +805,7 @@ static char ** libxl__build_device_model
                 if (strncmp(disks[i].vdev, "sd", 2) == 0) {
                     drive = libxl__sprintf
                         (gc, "file=%s,if=scsi,bus=0,unit=%d,format=%s,readonly=%s,cache=writeback",
-                         disks[i].pdev_path, disk, format, disks[i].readwrite ? "off" : "on");
+                         pdev_path, disk, format, disks[i].readwrite ? "off" : "on");
                 } else if (disk < 4) {
                     if (!disks[i].readwrite) {
                         LOG(ERROR, "qemu-xen doesn't support read-only IDE disk drivers");
@@ -786,7 +813,7 @@ static char ** libxl__build_device_model
                     }
                     drive = libxl__sprintf
                         (gc, "file=%s,if=ide,index=%d,media=disk,format=%s,cache=writeback",
-                         disks[i].pdev_path, disk, format);
+                         pdev_path, disk, format);
                 } else {
                     continue; /* Do not emulate this disk */
                 }
Index: xen-4.4.4-testing/tools/libxl/libxlu_disk_l.l
===================================================================
--- xen-4.4.4-testing.orig/tools/libxl/libxlu_disk_l.l
+++ xen-4.4.4-testing/tools/libxl/libxlu_disk_l.l
@@ -210,6 +210,8 @@ target=.*	{ STRIP(','); SAVESTRING("targ
                     free(newscript);
                 }
 
+dmmd:/.*	{ DPC->had_depr_prefix=1; DEPRECATE(0); }
+npiv:/.*	{ DPC->had_depr_prefix=1; DEPRECATE(0); }
 tapdisk:/.*	{ DPC->had_depr_prefix=1; DEPRECATE(0); }
 tap2?:/.*	{ DPC->had_depr_prefix=1; DEPRECATE(0); }
 aio:/.*		{ DPC->had_depr_prefix=1; DEPRECATE(0); }
